use CGI;
use Win32::AdminMisc;
use Win32::NetAdmin;
use Win32;
use strict;

# Fehlermeldungen von 'use strict' bei Funktionsaufruf '&$function()' vermeiden
no strict 'refs';

my $query    = new CGI;
my $encoding = $query->URL_ENCODED;
my $action   = $query->script_name;                 # CGI Pfad/Programmname fr <FORM> Tag

# konfigurierbare Werte
##########################################################################

my $method     = 'POST';                            # GET funktioniert ebenfalls
my $title      = 'WIN NT Benutzer-Verwaltung mit Win32 Perl';
my $caption    = '<FONT SIZE=+1 FACE="Arial"><B>WIN NT<BR>Benutzer-Verwaltung<BR>mit Win32 Perl</B></FONT>';
my $author     = 'betty.kainz@mobilkom.at (Betty Kainz)';
my $authorinfo = '<A HREF=\"mailto:betty.kainz\@mobilkom.at\"><B>Betty Kainz</B></A>';
my $warn       = "<B><FONT COLOR=\"maroon\">";
my $warn_end   = '</B></FONT><BR>';

# 'Window-target' und Farben
my $mtarget = 'left';                               # fr das Men
my $target  = 'right';                              # fr andere HTML-Seiten
my @colors  = ('white', 'lightblue', 'darkblue');

# Gre der Scrollboxen
my $scroll      = 12;
my $smallscroll = 8;

# Default Werte fr Benutzer-Verwaltung
#my $server         = GetPDC();
my $server         = '\\\\yourPDCname';			# PDC oder BDC - anpassen !
my $defaultpwd     = 'perlhacker';				# mu der Benutzer ndern
my $defaultgrp     = '';
my $defaultkomment = 'mit Win32 Perl erzeugt';
my $homeDir        = '';
my $scriptpath     = '';
my $passwordAge    = 0;
my $privilege      = USER_PRIV_USER;			# keine Apostrophen bei
my $flags          = UF_SCRIPT;					# solchen Zeichenketten
my $filter         = FILTER_NORMAL_ACCOUNT;		# verwenden !!!

# Hash-Keys nicht konfigurieren ! Hash-Values knnen fr die Anzeige einfach gendert werden.
# Benutzer-Verwaltung Formularfunktionen und Bezeichnungen
my %singforms  = ('AddUsrSingF'		=> 'hinzufgen',
                  'DelUsrSingF'		=> 'lschen',
                  'ERenUsrSingF'	=> 'umbenennen',
                  'GrpAddUsrSingF'	=> 'zu Gruppe(n) hinzufgen',
                  'GrpDelUsrSingF'	=> 'von Gruppe(n) entfernen');

# Gruppen-Verwaltung Formularfunktionen und Bezeichnungen
my %grpforms   = ('MakeGrpGrupF'	=> 'neue Gruppe(n) erstellen',
                  'DelGrpGrupF'		=> 'Gruppe(n) lschen',
                  'ShowGrpGrupF'	=> 'Gruppen Mitglieder anzeigen');

# Stapel Benutzer-Verwaltung Formularfunktionen und Bezeichnungen
my %multiforms = ('AddUsrMultF'		=> 'hinzufgen',
                  'DelUsrMultF'		=> 'lschen',
                  'GrpAddUsrMultF'	=> 'zu Gruppe(n) hinzufgen',
                  'GrpDelUsrMultF'	=> 'von Gruppe(n) entfernen');

# Verwaltungsfunktionen und Bezeichnungen
my %functions  = ('AddUsr'			=> 'Benutzerkonto hinzufgen',
                  'DelUsr'			=> 'Benutzerkonto lschen',
                  'ERenUsr'			=> 'Benutzerkonto umbenennen',
                  'GrpAddUsr'		=> 'zur Gruppe(n) hinzufgen',
                  'GrpDelUsr'		=> 'von Gruppe(n) entfernen',
                  'MakeGrp'			=> 'neue Gruppe(n) erstellen',
                  'DelGrp'			=> 'Gruppe(n) lschen',
                  'ShowGrp'			=> 'Gruppen Mitglieder anzeigen');

# Status Bezeichnungen
my %statustxt  = ('success'			=> 'Erfolgreich ! ',
                  'error'			=> "$warn <LI>Fehlgeschlagen ! ",
                  'badchar'			=> "entspricht nicht der NT Namenskonvention ! $warn_end\n",
                  'noname'			=> "Benutzername fehlt ! $warn_end\n",
                  'notexist'		=> "existiert nicht ! $warn_end\n",
                  'exists'			=> "existiert bereits ! $warn_end\n",
                  'nogrpadd'		=> 'konnte nicht hinzufgen zu Gruppe:',
                  'notmember'		=> "$warn <LI>ist nicht Mitglied der Gruppe",
                  'ismember'		=> "$warn <LI>ist bereits Mitglied der Gruppe",
                  'nomembers'		=> 'hat keine Mitglieder !',
                  'nogroup'			=> "$warn Kein Gruppenname angegeben ! $warn_end",
                  'noinfo'			=> "Keine Information vorhanden ! $warn_end\n");

######################################################
# Ab hier nichts mehr konfigurieren !
######################################################
# fr CGI.pm
my $BeSure			= $query->param('BeSure');
my $function		= $query->param('function');
my $userName		= $query->param('username');
my @userNames		= $query->param('username');
my $FullName		= $query->param('fullname');
my $password		= $query->param('password');
my $comment			= $query->param('comment');
my $newuserName		= $query->param('newusername');
my $trennzeichen	= $query->param('trennzeichen');
my $userlines		= $query->param('userlines');
my $group			= $query->param('groups');
my @groups			= $query->param('groups');

# 'use strict' zufriendenstellen ;-)
my $status		= '';
my @allusers	= ();
my @getgroups	= ();
my $date		= ();
my $subfunction;

# funktions-bezogene Titel fr Ergebnisseiten
my $resulttitle = "<H3>$functions{$function}</H3>";
 
################
# Programmanfang
################
if ( ! $query->param ) {						# Frameset erstellen
    CreateFrameset();							# falls kein Parameter ber-
}												# geben wird (erster Aufruf)
elsif ( defined($BeSure) ) {
    CreateHTML();								# Sicherheitsabfrage beim Lschen
    BeSure();									# von Benutzer oder Gruppen
}
else {
    if ( $function eq 'MenuF' ) {				# Fr das Men,
        @colors = reverse(@colors);				# Farben umkehren
        $target = $mtarget;						# Target auf linke Frame
    }
    if ( $function =~ /[^MenuF]F$/ ) {			# Fr Formularfunktionen
        $date		 = GetDate();
        $defaultkomment .= ", $date";
        @getgroups   = GetGroups();				# Domn-Gruppen Liste holen
        $subfunction = substr($function, 0, -5);# Verwaltungsfunktion extrahieren
        $function    = substr($function, -5);	# Formularfunktion von 
    }											# Zeichenkette extrahieren
    CreateHTML();
    print $resulttitle;
    &$function();								# Funktion aufrufen
}

###########################
# HTML-bezogene Funktionen
############################################
# Sub CreateFrameset - erstellt das Frameset
############################################
sub CreateFrameset {

    print $query->header;
    print "<HTML><HEAD><TITLE>$title</TITLE>\n";
    print "<META NAME=\"author\" CONTENT=\"$author\"></HEAD>\n";
    print "<FRAMESET COLS=\"30%,*\" FRAMEBORDER=\"0\" FRAMESPACING=0\">\n";
    print "     <FRAME SCROLLING=AUTO NORESIZE SRC=\"$action\?function=MenuF\" NAME=\"left\">\n";
    print "     <FRAME SCROLLING=AUTO NORESIZE SRC=\"$action\?function=CreateEmptyHTML\" NAME=\"right\">\n";
    print "</FRAMESET>\n";
    print $query->end_html;
}

####################################################
# Sub CreateHTML - erzeugt Headers und HTML Dokument
####################################################
sub CreateHTML {

    $| = 1;										# Flush STDOUT
    print $query->header(-target=>$target);		# MIME und Window-target Headers

    print $query->start_html(-title=>$title,	# HTML-Dokument erstellen
                             -author=>$author,
                             -meta=>{'keywords'=>'NT Perl Benutzer',
                                     'author'  =>$author},
                             -BGCOLOR=>$colors[0],
                             -TEXT=>$colors[2],
                             -LINK=>$colors[2],
                             -ALINK=>$colors[2],
                             -VLINK=>$colors[2]);
}

##########################################################
# Sub MenuF - erstellt das Men. Funktionen werden mittels
# der hiererstellten URL-encoded Zeichenketten aufgerufen
##########################################################
sub MenuF {

    my ($key, $value);
    print "$caption <HR>\n";
    print "<FONT SIZE=2 FACE=\"Arial\" COLOR=\"$colors[1]\"><B>Benutzer-Verwaltung:<BR>\n";
    foreach $key ( sort ( keys %singforms )) {
        print "<LI><A HREF=\"$action?function=$key\" target=\"right\">$singforms{$key}</A><BR>\n";
    }
    print "<P><B>Gruppen-Verwaltung:</B>";
    foreach $key ( sort ( keys %grpforms )) {
        print "<LI><A HREF=\"$action?function=$key\" target=\"right\">$grpforms{$key}</A><BR>\n";
    }
    print "<P><B>Stapel Benutzer-Verwaltung:</B>";
    foreach $key ( sort ( keys %multiforms )) {
        print "<LI><A HREF=\"$action?function=$key\" target=\"right\">$multiforms{$key}</A><BR>\n";
    }
    print $query->end_html;
}

#####################################################
# Sub CreateEmptyHTML - erzeugt eine leere HTML-Seite
#####################################################
sub CreateEmptyHTML {

    print $query->end_html;
}

#####################################################
# Sub EndForm - bildet Formular- und HTML- Abschlu
#####################################################
sub EndForm {

    # Name der aufzurufenden Funktion mittels eines versteckten Feldes
    # beim Abschicken des Formulares an das Programm bergeben
    print "<INPUT TYPE=hidden NAME=\"function\" VALUE=\"$subfunction\"><P>\n";
    print $query->submit(-name=>'submit', -value=>$functions{$subfunction});
    print $query->reset;
    print $query->endform;
    print $query->end_html;
}

######################################################################
# Sub SingF - erstellt HTML-Formulare fr die Benutzer-Verwaltung
######################################################################
sub SingF {
    my $usrselect = '';
    my $usrselectmulti = '';

    # Liste alle Benutzerkonten holen
    if (Win32::NetAdmin::GetUsers($server, $filter, \@allusers)) {

        # keine mehrfach Auswahl fr Umbennenen ('ERen') Funktion
        $usrselect = $query->popup_menu(-name=>'username', -values=>[@allusers], -default=>'-');

        # mehrfach Auswahl fr andere Funktionen erlauben
        $usrselectmulti = $query->popup_menu(-name=>'username', -values=>[@allusers],
                                             -multiple=>'true', -size=>$smallscroll,-default=>'-');
    }
    # Formular erzeugen
    print $query->startform(-method=>$method, -action=>$action, -encoding=>$encoding);
    print "<FONT SIZE=+1><B>Benutzer-Verwaltung - $functions{$subfunction}</B></FONT><P>\n";

    # Formular-Elemente fr 'Benutzer hinzufgen'
    if ($subfunction eq 'AddUsr' ) {
        print "<P><B>Benutzername:</B><BR>\n";
        print $query->textfield(-name=>'username', -default=>'', -size=>20, -maxlength=>20);
        print "<BR><B>Vollst\&auml\;ndiger Name <I>(optional)</I>:</B><BR>\n";
        print $query->textfield(-name=>'fullname', -default=>'', -size=>30, -maxlength=>58);
        print "<BR><B>Kennwort:</B><BR>\n";
        print $query->password_field(-name=>'password', -value=>$defaultpwd, -size=>14, -maxlength=>14);
        print "<BR><B>Beschreibung:</B><BR>\n";
        print $query->textfield(-name=>'comment', -default=>$defaultkomment, -size=>30, -maxlength=>48);
    }
    # zustzliche Formular-Elemente fr diverse Funktionen schrittweise hinzufgen
    unless (( $subfunction eq 'AddUsr' ) or ( $subfunction eq 'ERenUsr' )) {
        print "<B>Benutzername(n):</B><BR> $usrselectmulti\n";
    }
    if ( $subfunction eq 'ERenUsr' ) {
        print "<B>Benutzername:</B><BR>$usrselect\n";
        print "<P><B>neuer Benutzername:</B><BR>\n";
        print $query->textfield(-name=>'newusername', -default=>'', -size=>20, -maxlength=>20);
    }
    unless (( $subfunction eq 'DelUsr' ) or ( $subfunction eq 'ERenUsr' )) {
        print "<BR><B>Gruppe(n) ausw\&auml\;hlen:</B><BR>\n";
        print $query->popup_menu(-name=>'groups', -multiple=>'true',
                                 -size=>$smallscroll, -values=>[@getgroups], -default=>$defaultgrp);
    }
    if ( $subfunction eq 'DelUsr' ) {

        # Aufruf der Funktion 'BeSure' (Sicherheitsabfrage) mittels verstecktem Feld veranlassen
        print "<P>" . $query->hidden(-name=>'BeSure', -default=>'OK');

        # tatschliche Funktion in verstecktem Feld an das Programm bergeben
        print "<INPUT TYPE=hidden NAME=\"function\" VALUE=\"$subfunction\"><P>\n";
        print $query->submit(-name=>'submit', -value=>$functions{$subfunction});
        print $query->reset;
        print $query->endform;
        print $query->end_html;
    }
    else {
        EndForm();
    }
}

################################################################
# Sub GrupF - erstellt HTML-Formulare fr die Gruppen-Verwaltung
################################################################
sub GrupF {

    print $query->startform(-method=>$method, -action=>$action, -encoding=>$encoding);
    print "<FONT SIZE=+1><B>Gruppen-Verwaltung - $functions{$subfunction}</B></FONT><HR>\n";

    # Formular-Elemente fr diverse Funktionen schrittweise hinzufgen
    if ( $subfunction eq 'MakeGrp' ) {
        print "<P><B>Gruppenname:</B><BR>\n";
        print $query->textfield(-name=>'groups', -default=>'', -size=>25, -maxlength=>50);
        print "<P><B>Beschreibung:</B><BR>\n";
        print $query->textfield(-name=>'comment', -default=>$defaultkomment, -size=>30, -maxlength=>48);
    }
    else {
        print "<P><B>Gruppe(n) ausw\&auml\;hlen:</B><BR>\n";
        print $query->popup_menu(-name=>'groups', -multiple=>'true',
                                 -size=>$scroll, -values=>[@getgroups], -default=>'-');
    }
    if ( $subfunction eq 'DelGrp' ) {

            # Aufruf der Funktion 'BeSure' (Sicherheitsabfrage) mittels verstecktem Feld veranlassen
            print "<P>" . $query->hidden(-name=>'BeSure', -default=>'OK');

            # tatschliche Funktion in verstecktem Feld an das Programm bergeben
            print "<INPUT TYPE=hidden NAME=\"function\" VALUE=\"$subfunction\"><P>\n";
            print $query->submit(-name=>'submit', -value=>$functions{$subfunction});
            print $query->reset;
            print $query->endform;
            print $query->end_html;
    }
    else {
        print "<P>\n";
        EndForm();
    }
}

###############################################################
# Sub MultF - erstellt HTML-Formulare fr die Stapel-Verwaltung
###############################################################
sub MultF {

    print $query->startform(-method=>$method, -action=>$action, -encoding=>$encoding);
    print "<FONT SIZE=+1><B>Stapel-Verwaltung - $functions{$subfunction}</B></FONT><P>\n";

    # Formular-Elemente fr diverse Funktionen schrittweise hinzufgen
    if ($subfunction eq 'AddUsr' ) {
        print "<B>Benutzername;Vollst\&auml\;ndiger Name (Trennzeichen-getrennt)</B>\n";
    }
    else {
        print "<P><B>Benutzername1;Benutzername2;Benutzername3; usw.<BR>(Trennzeichen-getrennt)</B>\n";
    }
    print $query->textarea(-name=>'userlines', -default=>'', -rows=>4,
                           -maxrows=>256, -maxcolumns=>256,  -columns=>50);
    print "<BR><B>Trennzeichen angeben:</B><BR>\n";
    print $query->textfield(-name=>'trennzeichen', -default=>';', -size=>5, -maxlength=>5);
    unless ( $subfunction eq 'DelUsr' ) {
        print "<BR><B>Gruppe(n) ausw\&auml\;hlen:</B><BR>\n";
        print $query->popup_menu(-name=>'groups', -multiple=>'true',
                                 -values=>[@getgroups], -size=>$smallscroll, -default=>$defaultgrp);
    }
    if ( $subfunction eq 'AddUsr' ) {
        print "<BR><B>Beschreibung <I>(optional)</I>:</B><BR>\n";
        print $query->textfield(-name=>'comment', -default=>$defaultkomment, -size=>30, -maxlength=>48);
    }
    if ( $subfunction eq 'DelUsr' ) {

            # Aufruf der Funktion 'BeSure' (Sicherheitsabfrage) mittels verstecktem Feld veranlassen
            print "<P>" . $query->hidden(-name=>'BeSure', -default=>'OK');

            # tatschliche Funktion in verstecktem Feld an das Programm bergeben
            print "<INPUT TYPE=hidden NAME=\"function\" VALUE=\"$subfunction\"><P>\n";
            print $query->submit(-name=>'submit', -value=>$functions{$subfunction});
            print $query->reset;
            print $query->endform;
            print $query->end_html;
    }
    else {
        EndForm();
    }
}

########################################################################
# Sub BeSure - Sicherheitsabfrage beim lschen von Benutzer oder Gruppen
########################################################################
sub BeSure {

    my $subfunction = $function;

    print $query->startform(-method=>$method, -action=>$action, -encoding=>$encoding);

    # tatschliche Funktion in verstecktem Feld an das Programm bergeben
    print $query->hidden(-name=>'function', -default=>$subfunction);
    print "\n<H3>$warn \"$functions{$subfunction}\" wirklich durchf\&uuml\;hren ? $warn_end </H3><UL><B>\n";
    if ($userlines ne '') {

        # fhrende und nachstehende Leerzeichen entfernen
        $userlines =~ s/^\s+|\s+$//g;

        # Zeilen von Stapel Verwaltung parsen
        @userNames = split(/$trennzeichen/,$userlines);
    }
    if (( $userName ne '' ) or ( scalar(@userNames > 0))) {
        foreach $userName(@userNames) {
            $userName =~ s/^\s+|\s+$//g;
            print "<LI> \"$userName\" \n";
        }

        # Benutzernamen mittels verstecktem Feld an das Programm bergeben
        print $query->hidden(-name=>'username', -default=>[@userNames]);
    }
    if ( scalar(@groups > 0) )  {

        # Gruppennamen mittels verstecktem Feld an das Programm bergeben
        print $query->hidden(-name=>'groups', -default=>[@groups]);
        foreach (@groups) {
                print "<LI> \"$_\" \n";
        }
    }
    print "</UL><P>\n";
    print $query->submit(-name=>'submit', -value=>$functions{$subfunction});
    print $query->endform;
    print $query->end_html;

    # ...unbedingt notwendig, um die Funktion noch nicht auszufhren !
    exit;
}

########################
# Verwaltungs-Funktionen
##############################################################################
# AddUsr - berprft Angaben fr neue Benutzerkonten und ruft 'CreateUser' auf
##############################################################################
sub AddUsr {
    if ($userlines ne '') {								# Zeilen von Stapel Verwaltung parsen
        my @userdata = split(/\n/,$userlines);
        foreach (@userdata) {
            $_ =~ s/^\s+|\s+$//g;						# fhrende und nachstehende Leerzeichen entfernen
            my ($userName, $FullName) = split(/$trennzeichen/, $_);
            if ($userName ne '') {
                if ( ChkUsrChar($userName) == 1 ) {		# auf ungltige Zeichen berprfen
                    if (Win32::NetAdmin::UsersExist($server, $userName) ne '' ) {  # existiert er schon ?
                        $status = "$statustxt{'error'} \"$userName\" $statustxt{'exists'}";
                    }
                    else {								# Funktion 'CreateUser' aufrufen
                        $status = CreateUser($server, $userName, $FullName, $comment, @groups);
                    }
                }
                else {
                    $status = "$statustxt{'error'} \"$userName\" $statustxt{'badchar'}";
                }
            }
            else {
                $status =  "$statustxt{'error'} $statustxt{'noname'}";
            }
            $status .= "<HR>\n";
            print $status;
        }
    }
    else {
        if ($userName ne '') {
            if ( ChkUsrChar($userName) == 1 ) {
                if (Win32::NetAdmin::UsersExist($server, $userName) ne '') {
                      $status = "$statustxt{'error'} \"$userName\" $statustxt{'exists'}";
                }
                else {
                    $status = CreateUser($server, $userName, $FullName, $comment, @groups);
                }
            }
            else {
                 $status = "$statustxt{'error'} \"$userName\" $statustxt{'badchar'}";
            }
        }
        else {
            $status = "$statustxt{'error'} $statustxt{'noname'}";
        }
        print $status;
    }
    print $query->end_html;
}

##################################################
# Sub CreateUser - richtet neue Benutzerkonten ein
##################################################
sub CreateUser {
    my ($server, $userName, $FullName, $comment, @groups) = @_;
    my $allgroups  = '<UL>';
    my $groups;

    # Benutzerkonto anlegen
    if (Win32::NetAdmin::UserCreate($server, $userName, $password, $passwordAge, $privilege,
    $homeDir, $comment, $flags, $scriptpath) == 1) {

        # Vollstndigen Namen hinzufgen
        if (Win32::AdminMisc::UserSetMiscAttributes($server, $userName, USER_FULL_NAME=>$FullName) == 1) {

            # Flag setzen - 'Benutzer mu Kennwort beim nchsten Log-In ndern'
            if (Win32::AdminMisc::UserSetMiscAttributes($server, $userName, USER_PASSWORD_EXPIRED=>1) == 1) {
                foreach $groups(@groups) {

                    # Benutzer zu Gruppe hinzufgen
                    if (Win32::NetAdmin::GroupAddUsers($server, $groups, $userName)) {
                        $allgroups .= "<DD><LI>$groups";
                    }
                    else {
                        $allgroups .= "<DD><LI> $statustxt{nogrpadd}: $groups $warn_end";
                    }
                }
                $status  =  "<B>$statustxt{'success'}</B><UL>";
                $status .= "<LI><B>Benutzername:</B> $userName\n";
                $status .= "<LI><B>Vollstndiger Name:</B> $FullName\n";
                $status .= "<LI><B>Beschreibung:</B> $comment\n";
                $status .= "<LI><B>Basisverzeichnis:</B> $homeDir\n";
                $status .= "<LI><B>Anmeldeskript:</B> $scriptpath\n";
                $status .= "<LI><B>Gruppe(n):</B><BR>$allgroups</UL></UL>\n";
            }
        }
    }
    else {
        $status = $statustxt{'error'};
    }
    return($status);
}

####################################
# Sub DelUsr - lscht Benutzerkonten
####################################
sub DelUsr {

    if ( scalar(@userNames > 0 )) {
        foreach $userName(@userNames) {

            # berprfen ob der Benutzer existiert
            if (Win32::NetAdmin::UsersExist($server, $userName) ne '') {

                # Benutzerkonto lschen
                if (Win32::NetAdmin::UserDelete($server,$userName) == 1) {
                    $status .= "<LI><B>$statustxt{'success'} \"$userName\" </B>\n";
                }
                else {
                    $status .= "$statustxt{'error'} \"$userName\" $warn_end\n";
                }
            }
            else {
                $status .= "$statustxt{'error'} \"$userName\" $statustxt{'notexist'}";
            }
        }
    }
    else {
        $status = "$statustxt{'error'} $statustxt{'noname'}";
    }
    print $status;
    print $query->end_html;
}

####################################
# Sub ERen - nennt Benutzerkonten um
####################################
sub ERenUsr {

    if (( $userName  ne '' ) && ( $newuserName  ne '' )) {

        # auf ungltige Zeichen berprfen
        if ( ChkUsrChar($newuserName) == 1 ) {
            # berprfen ob der Benutzer existiert
            if (Win32::NetAdmin::UsersExist($server, $userName) eq '') {
                $status = "$statustxt{'error'} \"$userName\" $statustxt{'notexist'}";
            }
            # berprfen ob der neue Benutzername bereits existiert
            elsif (Win32::NetAdmin::UsersExist($server, $newuserName) ne '') {
                $status = "$statustxt{'error'} \"$userName\" $statustxt{'exists'}";
            }
            # Benutzerkonto umbennen
            elsif (Win32::AdminMisc::RenameUser($server, $userName, $newuserName) == 1) {
                $status = "<B>$statustxt{'success'} \"$userName\" -> \"$newuserName\"</B>\n";
            }
            else {
                $status = Win32::FormatMessage(Win32::GetLastError());
            }
        }
        else {
            $status = "$statustxt{'error'} \"$userName\" $statustxt{'badchar'}";
        }
    }
    else {
        $status = "$statustxt{'error'} $statustxt{'noname'}";
    }
    print $status;
    print $query->end_html;
}

#################################################
# Sub GrpAddUsr - fgt Benutzer zu Gruppen hinzu
#################################################
sub GrpAddUsr {

    my $groups;

    # Zeilen von Stapel Formular parsen
    if ( $userlines ) {
        @userNames = split(/$trennzeichen/,$userlines);
    }

    if ( scalar(@userNames > 0 )) {

        foreach $userName(@userNames) {
            $userName =~ s/^\s+|\s+$//g;
            my $status = "<B>Benutzer \"$userName\":<UL>";

            if ( $userName  ne '') {

                # berprfen ob der Benutzer existiert
                if (Win32::NetAdmin::UsersExist($server, $userName) ne '') {
                    if ( scalar(@groups > 0 )) {
                        foreach $groups(@groups) {

                            # berprfen ob der Benutzer bereits Gruppenmitglied ist
                            if (Win32::NetAdmin::GroupIsMember($server, $groups, $userName) == 1) {
                                $status .= "$statustxt{'ismember'} \"$groups\"</FONT>";
                                next;
                            }
                            # Benutzer zu Gruppe hinzufgen
                            if (Win32::NetAdmin::GroupAddUsers($server, $groups, $userName) == 1) {
                                $status  .=  "<LI>$statustxt{'success'} \"$userName\" -> \"$groups\"\n";
                                next;
                            }
                            if (Win32::NetAdmin::GroupAddUsers($server, $groups, $userName) == 0) {
                                $status .= "$statustxt{'error'} \"$userName\" -> \"$groups\"<BR>
                                Grund: Win32::FormatMessage(Win32::GetLastError()) $warn_end\n";
                                next;
                            }
                        }
                    }
                    else {
                        $status = "$statustxt{'error'} $statustxt{'nogroup'}";
                    }
                }
                else {
                    $status  .= "$statustxt{'error'} \"$userName\" $statustxt{'notexist'}";
                }
            }
            $status .="</UL><HR>\n";
            print $status;
        }
    }
    else {
        print "$statustxt{'error'} $statustxt{'noname'}";
    }
    print $query->end_html;
}

##############################################
# Sub GrpDelUsr - entfernt Benutzer von Gruppe
##############################################
sub GrpDelUsr {

    # Zeilen von Stapel Formular parsen
    if ( $userlines ) {
        @userNames = split(/$trennzeichen/,$userlines);
    }

    if ( scalar(@userNames > 0 )) {
        foreach $userName(@userNames) {
            $userName =~ s/^\s+|\s+$//g;        # fhrende und nachstehende Leerzeichen entfernen
            my $status    = "<B>Benutzer \"$userName\"<UL>";

            if ( $userName ne '' ) {

                # berprfen ob der Benutzer existiert
                if ( Win32::NetAdmin::UsersExist($server, $userName) ne '' ) {
                    if ( scalar(@groups > 0 )) {
                        foreach (@groups) {

                            # berprfen ob der Benutzer bereits Gruppenmitglied ist
                            if ( Win32::NetAdmin::GroupIsMember($server, $_, $userName) == 1 ) {

                                # Benutzer von Gruppe entfernen
                                if ( Win32::NetAdmin::GroupDeleteUsers($server, $_, $userName ) == 1) {
                                    $status .= "<LI>$statustxt{'success'} \"$_\"\n";
                                }
                                else {
                                    $status .= "<LI>$statustxt{'error'} \"$_\"";
                                }
                            }
                            else {
                                $status .= "$statustxt{'notmember'} \"$_\"</FONT>";
                                next;
                            }
                        }
                    }
                    else {
                        $status = "$statustxt{'error'} $statustxt{'nogroup'}";
                    }
                }
                 else {
                    $status  .= "$statustxt{'error'} \"$userName\" $statustxt{'notexist'}";
                }
            }
            else {
                $status .= "$statustxt{'error'} $statustxt{'noname'}";
            }
        $status .= "</UL><HR>";
        print $status;
        }
    }
     else {
        print "$statustxt{'error'} $statustxt{'noname'}";
    }
    print $query->end_html;
}

########################################
# Sub MakeGrp - erzeugt eine neue Gruppe
########################################
sub MakeGrp {

    $group =~ s/^\s+|\s+$//g;        # fhrende und nachstehende Leerzeichen entfernen

    if ($group ne '') {

        # neue Gruppe erzeugen
        if (Win32::NetAdmin::GroupCreate($server, $group, $comment) == 1) {
            $status  =  "<B>$statustxt{'success'} \"$group\"";
        }
        else {
            $status = "$statustxt{'error'} \"$group\" $statustxt{'exists'}";
        }
    }
    else {
            $status = "$statustxt{'error'} $statustxt{'nogroup'}";
    }
    print $status;
    print $query->end_html;
}

#################################
# Sub DelGrp - lscht eine Gruppe
#################################
sub DelGrp {

    if ( scalar(@groups > 0 )) {
        foreach(@groups) {

            # Gruppe entfernen
            if (Win32::NetAdmin::GroupDelete($server, $_) != 0) {
                $status .=  "<LI><B>$statustxt{'success'} \"$_\"</B>\n";
            }
            else {
                $status .= "$warn $statustxt{'error'} \"$_\"
                <BR>Grund: " . Win32::FormatMessage(Win32::GetLastError()) . $warn_end;
            }
        }
    }
    else {
            $status = "$statustxt{'error'} $statustxt{'nogroup'}";
    }
    print $status;
    print $query->end_html;
}

###########################################
# Sub ShowGrp - zeigt Gruppen-Mitglieder an
###########################################
sub ShowGrp {

    my @grpmembers = '';
    if ( scalar(@groups > 0 )) {
        foreach $group(sort(@groups)) {
            my $status = '';

            # Liste der Gruppen-Mitglieder holen
            if (Win32::NetAdmin::GroupGetMembers($server, $group, \@grpmembers) == 1 ) {
                if ( scalar(@grpmembers > 0 )) {
                    my $count = scalar(@grpmembers);    # vielleicht interessant
                    $status = "<B>Die Gruppe \"$group\" hat $warn $count </FONT> Mitglieder:</B><UL>\n";
                    foreach(@grpmembers) {
                        $status .= "<LI>$_\n";
                    }
                    $status .= "</UL><HR>\n";
                }
                else {
                    $status = "<LI><B>Gruppe \"$group\" $statustxt{'nomembers'}";
                }
            }
            else {
                $status = "<HR>$statustxt{'error'}  \"$group\" - $statustxt{'noinfo'} $warn_end </FONT><HR>\n";
            }
            print $status;
        }
    }
    else {
        $status = "$statustxt{'error'} $statustxt{'nogroup'}";
        print $status;
    }
    print $query->end_html;
}

################################
# diverse zustzliche Funktionen
###############################################
# Sub GetGroups - holt eine Liste aller Gruppen
###############################################
sub GetGroups {

    my $netgroups;
    my $getgroups;
    my @getgroups = ();

    open(GROUPS, "net group /DOMAIN |") || die $!;	# Dieser Systemaufruf
    my @netgroups = (<GROUPS>);						# bleibt zur Zeit
    close(GROUPS);									# leider nicht erspart.
    foreach $netgroups(@netgroups) {
        if ( $netgroups =~ /^\*/ ) {					# Liste in ein
            push(@getgroups, split(/\s+\*/,$netgroups));# brauchbares
        }												# Format bringen
    }
    foreach $getgroups(@getgroups) {
        chomp($getgroups);
        $getgroups =~ s/^\*//g;                     
        $getgroups =~ s/\s+$//g;
        $getgroups =~ s///g;						# Umlaute umwandeln
        $getgroups =~ s///g;
        $getgroups =~ s///g;
        $getgroups =~ s///g;
        $getgroups =~ s///g;
        $getgroups =~ s///g;
        $getgroups =~ s///g;
    }
    return(@getgroups);
}

##################################################################
# Sub ChkUsrChar - berprft Benutzernamen nach ungltigen Zeichen
##################################################################
sub ChkUsrChar {

    my $userName = $_[0];
    if (( $userName =~ /[ \/ \\ \[ \] : ; = , + * ? < > ]/ ) or ( length($userName) > 20 )) {
       return(0);
    }
    else {
       return(1);
    }
}

########################################
# Sub GetDate - aktuelles Datum ausgeben
########################################
sub GetDate {

   my ($day,$month,$year) = (localtime(time))[3,4,5];
   $date = sprintf ("%02d.%02d.%04d", $day, $month++, $year + 1900);
   return ($date);
}

#################################################################
# Sub GetPDC - (PDC) Primren Domnen-Controller ausfindig machen
#################################################################
sub GetPDC {

    my $Domain = "\\\\";
    $Domain .= Win32::DomainName;
    $server = Win32::AdminMisc::GetPDC($Domain);
    return ($server);
}
